#include <Arduino.h>

#ifndef _csv_str_h
#define _csv_str_h
#include "csv_str.h"
#endif


void csvCheck(void);

extern void ReadEEPhdStrPv(void);
extern void ElementDraw(int, int, byte);
extern void TextInfo(int fx, int fy, char* ptxt);
extern void TextInfoPos(int fx, int fy, char* ptxt, byte poskorr, byte option);
extern void ButtonCol(byte fx, byte fy, int color);
extern void DrawPanel(int fx, int fy, int appear);
extern void TextPanel(int fx, int fy, char* ptxt);
extern void DrawKey(int fx, int fy, uint8_t butt, int tcolor, char *sptr);
extern void FarbfelderInit(uint8_t xko, uint8_t yko, char *ts);
extern void SigScreen (int fx, int fy, int corner);
extern void ShScreen  (int fx, int fy, int corner);
extern void ShHScreen  (int fx, int fy, int corner);
extern void SigName (int fx, int fy, char* ptxt);
extern void FeldFarbe(byte fx, byte fy, int colour);


#define XDIM 13 //8 //13 // fuer Arrays immer "big"
#define YDIM 12 //7 //12 // Feldkoordinaten

#define XQDIM      64  // XBus Queue

#define TRACK       9
#define FELDSX     60
#define FELDSY     40


#define DEFDIM     40
#define RMPINSTART 22  // Start PA0.0 (Belegtmelder)
#define RMDIM      24
#define XWnum      10
#define MAXFWEG    20
#define AnzWeichen 32

#define LDIM        4 // Linkxy-Array

#define DETECTSET  0x80   // Abschnitt mit Fahrzeug belegt
#define DETECTRES ~0x80

#define FSTRBEL    0x20   // Element mit Fstr. belegt
#define FSTRFREI  ~0x20

#define FSTRSTART  0x40   // Start einer Fstr.
#define FSTRTRATS ~0x40

#define DKWab 0
#define DKWcd 1

#define indicTFdb 1  // Touchfeedback
#define indicRun  2  // Run (blinker)
#define indicTPwr 3  // Trackpower
#define indicBusy 4  // Zentrale Busy
   
// 16Bit in StpA[][], Adresse plus Bits
/*
  ddsz raaa aaaa aaaa
  dd:       2 Bit delay
    s:      1 Bit swap
     z:     1 Bit 2.adr.
       r:   1 Bit reserved
        a: 11 Bit adress
  Bitzaehlung 16 bit fuer Shift:
  1111 1100 0000 0000
  5432 1098 7654 3210
*/
#define ADRMASK   0x07FF      // 11 Bit
#define ADRZWEI   0x1000      // Flag: Folgeadresse vorhanden
#define ADRSWAP   0x2000      // Flag: Weichenlage tauschen
#define ADRdSHT   14          // 14 bit Shift fuer dd
#define ADRsSHT   13          // 13 bit Shift fuer s
#define ADR1DKW   0x0800      // Flag: DKW mit einem Antrieb
#define GLSPBIT   0x8000      // Flag: EW ist Gleissperre (in Eladress)


typedef struct {
  uint8_t  x;
  uint8_t  y;
  uint8_t  Rx;     // Anfang einer Fahrstrasse, Zweck: Fstr.Aufloesung
  uint8_t  Ry;     // "
  uint8_t  RevRel; // Aufloesung dann, wenn Startabschnitt frei (0/1)
  uint8_t  ReleaseCnt;
} RMITEM;


typedef struct {
  uint16_t Eladress;
  uint8_t  Elykoord;
  uint8_t  Elxkoord;  
  uint16_t ElaDKWcd;  // Dig.Adr und Swap-Bit
  uint8_t  LageDKWcd; 
  char     Elstr[9];
} WITEM;

typedef struct {
  byte xyKo;    // Button Positionen (x<<4 + y)
  byte Keytype; // 0: Fweg, 1:FS, 2: Fwn, 3: <>
} KYITEM;

typedef struct {
  uint8_t  x;
  uint8_t  y;
  uint8_t  opt;
  bool exist;
} MEITEM;

#define RCMAX     4           // Anzahl der RCL-Klassen (0-4)
extern uint8_t  GL_RouteClass;

extern char     FirstLine[];
extern int      xpos;
extern int      ypos;
extern uint8_t  StpM[][XDIM + 1];
extern uint16_t StpA[][XDIM + 1];
extern uint8_t  StpS[][XDIM + 1];
extern WITEM    Weiche[];
extern KYITEM   ButtField[];
extern byte     GL_ButtCnt;
extern RMITEM   RMKoord[];
extern uint8_t  RMmax;
extern uint8_t  GL_sqButtX;
extern uint8_t  GL_sqButtY;
extern bool     GL_sqExist;

extern int16_t  Fweg[][XWnum];
extern uint8_t  GL_AnzFweg;
extern uint8_t  RAM_EEPstr[];
extern uint8_t  PultPV[];
extern MEITEM   Melder[];
extern uint8_t  GL_xmax;
extern uint8_t  GL_ymax;

//    red  green  blue
// rrrr rggg|gggb bbbb    16bit colour

#define BLACK       0x0000
#define WHITE       0xFFFF
#define YELLOW      0xFFE0
#define RED         0xF800
#define LGREEN      0x07E0
#define GREEN       0x0400
#define GRAY        0xC618
#define DGRAY       0x8410
#define SILGRAY     0xAD55
#define OFFGRAY     0xD699
#define NAVY        0x0010
#define BLUE        0x001F

#define EXPGN       0x0780
#define EXPBL       0x0017
// nach Color Picker
#define KAKI        0xFE68
#define GEGN        0xD7C8
#define WCBLAU      0x7559
#define BLROT       0xEB2A
#define LBLUE       0x567D
#define WHITEDIM1   0xFFDF
#define WHITEDIM2   0xF7BE
#define WHITEDIM3   0xF79E  // alle zu weiss

//
